
#include <stdio.h>
#include <stdlib.h>
#include <string.h>



  #define longlong long long
  // RDTSC puts the result in EAX and EDX. We tell gcc to use those registers
  // for "low" and "high"
  #if defined(__i386__) || defined(__x86_64__)
    #define GETCOUNTER(low,high) \
            __asm__ volatile ("rdtsc" : "=a" (low), "=d" (high));
  #else
    #define GETCOUNTER(low,high) \
            printf ("Reading of performance counters is supported only on Intel x86\n"); \
            exit(1);
  #endif



/* This is the function that actually reads the performance counter. */
inline unsigned longlong read_ppc(void) {
  unsigned long pclow, pchigh;
  unsigned longlong lowhigh;

  GETCOUNTER(pclow, pchigh);
  
  // printf ("Read low=0x%08lx high=0x%08lx\n", low, high);

  // Put the 64-bit value together
  lowhigh = ((unsigned longlong)pclow) | ((unsigned longlong)pchigh << 32);


  return lowhigh ;
}

struct S { int a ; int b ; } ;
#define Val_int(e) (((e) << 1) | 1)

unsigned char t[16*1024*1024];
unsigned longlong count1, count2, count0;

int main(void)
{
  int i;
  char *st = (char*)(((int) t + 511) & ~511);
  struct S p = {0 , st  };

  count0 = read_ppc();
  for (i=0; i<8*1024*1024; i++)
    st[i] = i % 256;
 
  count1 = read_ppc();

  forget_spill_fat(&p,Val_int(1*512*1024));

  count2 = read_ppc();

  printf("time : %lld,realize:%lld\n", count2 - count1, count1 - count0);
  return 0;
}

