(**************************************************************************)
(*                                                                        *)
(*  This file is part of Frama-C.                                         *)
(*                                                                        *)
(*  Copyright (C) 2007                                                    *)
(*    CEA (Commissariat  l'nergie Atomique)                             *)
(*                                                                        *)
(*  you can redistribute it and/or modify it under the terms of the GNU   *)
(*  Lesser General Public License as published by the Free Software       *)
(*  Foundation, version 2.1.                                              *)
(*                                                                        *)
(*  It is distributed in the hope that it will be useful,                 *)
(*  but WITHOUT ANY WARRANTY; without even the implied warranty of        *)
(*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *)
(*  GNU Lesser General Public License for more details.                   *)
(*                                                                        *)
(*  See the GNU Lesser General Public License version 2.1                 *)
(*  for more details (enclosed in the file licenses/LGPLv2.1).            *)
(*                                                                        *)
(**************************************************************************)

(* $Id: gtk_helper.mli,v 1.7 2008/03/06 14:10:17 uid528 Exp $ *)

(** Generic Gtk helpers. *)

val apply_tag : GText.buffer -> GText.tag -> int -> int -> unit
val remove_tag : GText.buffer -> GText.tag -> int -> int -> unit
val cleanup_tag : GText.buffer -> GText.tag -> unit
val expand_to_path : GTree.view -> Gtk.tree_path -> unit
val make_tag : 
  GText.buffer -> name:string -> GText.tag_property list -> GText.tag

val make_formatter : GText.buffer -> Format.formatter
val redirect : Format.formatter -> GText.buffer -> unit

(*
Local Variables:
compile-command: "LC_ALL=C make -C ../.. -j"
End:
*)
