(**************************************************************************)
(*                                                                        *)
(*  This file is part of Frama-C.                                         *)
(*                                                                        *)
(*  Copyright (C) 2007                                                    *)
(*    CEA (Commissariat  l'nergie Atomique)                             *)
(*                                                                        *)
(*  you can redistribute it and/or modify it under the terms of the GNU   *)
(*  Lesser General Public License as published by the Free Software       *)
(*  Foundation, either version 3 of the License, or (at your option)      *)
(*  any later version.                                                    *)
(*                                                                        *)
(*  It is distributed in the hope that it will be useful,                 *)
(*  but WITHOUT ANY WARRANTY; without even the implied warranty of        *)
(*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *)
(*  GNU Lesser General Public License for more details.                   *)
(*                                                                        *)
(*  See the GNU Lesser General Public Licence version 3 for more details  *)
(*  (enclosed in the file licences/LGPLv3).                               *)
(*                                                                        *)
(**************************************************************************)

(* $Id: signature.mli,v 1.1 2007/12/12 13:16:46 uid568 Exp $ *)

module type NAME = sig val name: string end

module type SIZE = sig val size: int end

module type NAME_SIZE = sig
  val name: string
  val size: int
end

(** {2 Signatures to provide to some computation builders} *)

module type NAME_DPDS = sig
  val name: Project.Computation.Name.t
    (** Name of the generated internal state. *)
  val dependencies: Project.Computation.t list
    (** Dependencies of the generated internal state. *)
end

module type NAME_SIZE_DPDS = sig
  include NAME_DPDS
  val size:int
    (** Initial size of the generated internal state. *)
end

(*
Local Variables:
compile-command: "LC_ALL=C make -C ../.. -j"
End:
*)
